import java.lang.*;
import java.io.*;
import java.lang.reflect.*;
import java.util.*;

public class AitGen {
 public static final String APP_NAME       = "SE_Xlet";

 public static final int APP_NUM           = 20;

 public static final String BASE_DIR       = "/";
 public static final String CLASSPATH_EXT  = "";

 public static final String XLET_CLASS     = "SeXlet";

 public static final String COMPILE_SCRIPT = "xbuild.bat";

 public static final int MAXBUF    = 0x1000;

 public static final int Application_Information_Section = 0x74;

 public static final int APP_DVB_J = 0x01;

 public static final int ORG_ID    = 0x1C8;
 public static final int APP_ID    = 0x4000;

 public static final int AUTOSTART = 0x01;

 public static final int application_descriptor                = 0x00;
 public static final int application_name_descriptor           = 0x01;
 public static final int transport_protocol_descriptor         = 0x02;
 public static final int dvb_j_application_descriptor          = 0x03;
 public static final int dvb_j_application_location_descriptor = 0x04;

 private static void put_short(byte tab[],int pos,int val) {
  tab[pos]=(byte)((val>>8)&0xff);
  tab[pos+1]=(byte)(val&0xff);
 }

 private static void put_word(byte tab[],int pos,int val) {
  put_short(tab,pos,(val>>16)&0xffff);
  put_short(tab,pos+2,val&0xffff);
 }

 private static void put_length(byte buf[],int off,int length) {
  buf[off]=(byte)(((int)buf[off]&0xf0)|((byte)((length>>8)&0x0f)));
  buf[off+1]=(byte)(length&0xff);
 }

 private static int put_app(byte[] buf,int pos,int idx) {
  put_word(buf,pos,ORG_ID);
  pos+=4;

  put_short(buf,pos,APP_ID+idx);
  pos+=2;

  buf[pos++]=(byte)AUTOSTART; //application_control_code  

  int appdescloop_size_off=pos;
  buf[pos++]=(byte)0x00;      //reserved
  pos++;

  //application_descriptor
  buf[pos++]=(byte)application_descriptor;
  buf[pos++]=(byte)0x09;

  buf[pos++]=(byte)0x05;      //application_profiles_length

  buf[pos++]=(byte)0x00;      //profile
  buf[pos++]=(byte)0x01;
  buf[pos++]=(byte)0x01;      //major
  buf[pos++]=(byte)0x00;      //minor
  buf[pos++]=(byte)0x02;      //micro

  buf[pos++]=(byte)0x00;      //service_bound_flag = 0; visibility = 0
  buf[pos++]=(byte)0xff;      //application_priority
  buf[pos++]=(byte)0x00;      //transport_protocol_label

  //application_name_descriptor
  buf[pos++]=(byte)application_name_descriptor;
  buf[pos++]=(byte)(3+1+APP_NAME.length());

  buf[pos++]=(byte)'e';                  //ISO_639_language_code
  buf[pos++]=(byte)'n';
  buf[pos++]=(byte)'g';

  
  buf[pos++]=(byte)APP_NAME.length();    //application_name_length

  for(int i=0;i<APP_NAME.length();i++) {
   buf[pos++]=(byte)APP_NAME.charAt(i);
  }

  //dvb_j_application_descriptor
  buf[pos++]=(byte)dvb_j_application_descriptor;
  buf[pos++]=(byte)0x00;

  //dvb_j_application_location_descriptor
  String xletname="oc.ht"+idx+".xlet.p"+idx+"."+XLET_CLASS;

  buf[pos++]=(byte)dvb_j_application_location_descriptor;
  buf[pos++]=(byte)(2+BASE_DIR.length()+CLASSPATH_EXT.length()+xletname.length());

  buf[pos++]=(byte)BASE_DIR.length();         //base_directory_length

  for(int i=0;i<BASE_DIR.length();i++) {
   buf[pos++]=(byte)BASE_DIR.charAt(i);
  }

  buf[pos++]=(byte)CLASSPATH_EXT.length();    //classpath_extension_length

  for(int i=0;i<CLASSPATH_EXT.length();i++) {
   buf[pos++]=(byte)CLASSPATH_EXT.charAt(i);
  }
  
  for(int i=0;i<xletname.length();i++) {
   buf[pos++]=(byte)xletname.charAt(i);
  }

  put_length(buf,appdescloop_size_off,pos-appdescloop_size_off-2);

  return pos;
 }

 private static byte[] do_gen_ait(String codebase) {
  byte buf[]=new byte[MAXBUF];
  int pos=0;

  int crc_start=pos;

  buf[pos++]=(byte)Application_Information_Section;

  int size_off=pos;
  buf[pos++]=(byte)0x80;      //section_syntax_indicator = 1
  pos++;                      //section_length

  int sec_start=pos;

  buf[pos++]=(byte)0x00;      //test_application_flag
  buf[pos++]=(byte)APP_DVB_J; //application_type
  buf[pos++]=(byte)0x01;      //reserved = 0; version_number = 0; current_next_indicator = 1

  buf[pos++]=(byte)0x00;      //section_number
  buf[pos++]=(byte)0x00;      //last_section_number

  int commdesc_size_off=pos;

  buf[pos++]=(byte)0x00;      //reserved
  pos++;                      //common_descriptors_length

  //transport_protocol_descriptor
  buf[pos++]=(byte)transport_protocol_descriptor;
  buf[pos++]=(byte)(4+codebase.length());

  buf[pos++]=(byte)0x00;
  buf[pos++]=(byte)0x03;      //HTTP over IC
  buf[pos++]=(byte)0x00;      //transport_protocol_label

  buf[pos++]=(byte)codebase.length();  //URL_base_length

  for(int i=0;i<codebase.length();i++) {
   buf[pos++]=(byte)codebase.charAt(i);
  }

  put_length(buf,commdesc_size_off,pos-commdesc_size_off-2);

  int apploop_size_off=pos;
  buf[pos++]=(byte)0x00;      //reserved
  pos++;

  for(int i=0;i<APP_NUM;i++) {
   pos=put_app(buf,pos,2*i+1);
  }

  put_length(buf,apploop_size_off,pos-apploop_size_off-2);

  int crc_end=pos;
  int sec_end=pos+4;

  put_length(buf,size_off,sec_end-sec_start);

  int crc32=0;

  put_word(buf,pos,crc32);

  int size=sec_end;

  byte data[]=new byte[size];  
  System.arraycopy(buf,0,data,0,size);

  return data;
 }

 private static void copy_file(String srcfile,String dstfile) throws Throwable {
  int i=dstfile.lastIndexOf('\\');
  String dirname=dstfile.substring(0, i);
  
  new File(dirname).mkdirs();

  Process p=Runtime.getRuntime().exec("cmd.exe /C copy "+srcfile+" "+dstfile);
  p.waitFor();
 }

 private static void gen_xlet_class(int idx) throws Throwable {
  String pkgname="oc.ht"+idx+".xlet.p"+idx;

  FileOutputStream fos=new FileOutputStream(XLET_CLASS+".java",false);

  String sdata="package "+pkgname+";\n";
  fos.write(sdata.getBytes());

  String xletcode=XLET_CLASS+".code";

  File f=new File(xletcode);
  int size=-1;

  try {
   size=(int)f.length();
  } catch(Throwable t) {}

  if (size>0) {
   FileInputStream fis=new FileInputStream(xletcode);
   byte data[]=new byte[size];
   fis.read(data);
   fis.close();

   fos.write(data);
  } 

  fos.close();

  Process p=Runtime.getRuntime().exec("cmd.exe /C "+COMPILE_SCRIPT);
  p.waitFor();

  (new File(XLET_CLASS+".java")).delete();

  String srcfile="oc.ht"+idx+".xlet.p"+idx+"."+XLET_CLASS;
  String dstfile="xlet.p"+idx+"."+XLET_CLASS;

  copy_file(srcfile.replace('.','\\')+".class",dstfile.replace('.','\\')+".class");
 }

 public static void main(String args[])  throws Throwable {
  try {

   if (args.length!=2) {
    System.out.println("usage: filename codebase");
    System.exit(-1);
   }

   String filename=args[0];
   String codebase=args[1];

   byte data[]=do_gen_ait(codebase);

   if (data!=null) {
    FileOutputStream fos=new FileOutputStream(filename,false);
    fos.write(data);
    fos.close();
   }

   for(int i=0;i<APP_NUM;i++) {
    gen_xlet_class(2*i+1);
   }

  } catch(Throwable e) {
   e.printStackTrace();
  } 
 }

}
